package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataHarmPhasicIMapper;
import com.pqs9900.pojo.HisData.DataHarmPhasicI;
import com.pqs9900.service.HisData.DataHarmPhasicIService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

@Service
public class DataHarmPhasicIServiceImpl implements DataHarmPhasicIService {

    private static final Logger logger= LoggerFactory.getLogger(DataHarmPhasicIServiceImpl.class);

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;


    @Autowired
    DataHarmPhasicIMapper dataHarmPhasicIMapper;


    @Override
    public int saveDataHarmPhasicI(DataHarmPhasicI dataHarmPhasicI) {
        return dataHarmPhasicIMapper.insert(dataHarmPhasicI);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataHarmPhasicI(List<DataHarmPhasicI> list) {
        return dataHarmPhasicIMapper.insertDataHarmPhasicI(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataHarmPhasicI 谐波电流角度数据
     */
    @Override
    public Future insertDataHarmPhasicIExecutor(List<DataHarmPhasicI> listDataHarmPhasicI) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataHarmPhasicI.size() / (double) inum);
                    List<DataHarmPhasicI> tmpListDataHarmPhasicI = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataHarmPhasicI.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataHarmPhasicI.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataHarmPhasicI.addAll(listDataHarmPhasicI.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataHarmPhasicIMapper.insertDataHarmPhasicI(tmpListDataHarmPhasicI);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("谐波电流角度表导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
